var FCKDragTableHandler = 
{
	"_DragState" : 0,
	"_LeftCell" : null,
	"_RightCell" : null,
	"_MouseMoveMode" : 0,	// 0 - find candidate cells for resizing, 1 - drag to resize
	"_ResizeBar" : null,
	"_GetWindowScrollX" : function( w )
	{
		var scrollX = 0 ;
		if ( w.document.documentElement && w.document.documentElement.scrollLeft ) 
			scrollX = w.document.documentElement.scrollLeft ;
		else if ( w.document.body && w.document.body.scrollLeft )
			scrollX = w.document.body.scrollLeft ;
		else if ( w.scrollX )
			scrollX = w.scrollX ;
		return scrollX ;
	},
	"_GetWindowScrollY" : function( w )
	{
		var scrollY = 0 ;
		if ( w.document.documentElement && w.document.documentElement.scrollTop )
			scrollY = w.document.documentElement.scrollTop ;
		else if ( w.document.body && w.document.body.scrollTop )
			scrollY = w.document.body.scrollTop ;
		else if ( w.scrollY )
			scrollY = w.scrollY ;
		return scrollY ;
	},
	"_GetDocumentPosition" : function( w, node )
	{
		var x = 0 ;
		var y = 0 ;
		var curNode = node ;
		while ( curNode && curNode != w.document.body )
		{
			x += curNode.offsetLeft - curNode.scrollLeft ;
			y += curNode.offsetTop - curNode.scrollTop ;
			curNode = curNode.offsetParent ;
		}
		return { "x" : x, "y" : y } ;
	},
	"_GetWindowPosition" : function( w, node )
	{
		var pos = FCKDragTableHandler._GetDocumentPosition( w, node ) ;
		pos.x -= FCKDragTableHandler._GetWindowScrollX( w ) ;
		pos.y -= FCKDragTableHandler._GetWindowScrollY( w ) ;
		return pos ;
	},
	"_IsInsideNode" : function( w, domNode, pos )
	{
		var myCoords = FCKDragTableHandler._GetWindowPosition( w, domNode ) ; 
		var xMin = myCoords.x ;
		var yMin = myCoords.y ;
		var xMax = parseInt( xMin ) + parseInt( domNode.offsetWidth ) ;
		var yMax = parseInt( yMin ) + parseInt( domNode.offsetHeight ) ;
		if ( pos.x >= xMin && pos.x <= xMax && pos.y >= yMin && pos.y <= yMax )
			return true;
		return false;
	},
	"_GetBorderCells" : function( w, tableNode, evt )
	{
		// Enumerate all the cells in the table.
		var cells = [] ;
		for ( var i = 0 ; i < tableNode.rows.length ; i++ )
		{
			var r = tableNode.rows[i] ;
			for ( var j = 0 ; j < r.cells.length ; j++ )
				cells.push( r.cells[j] ) ;
		}

		if ( cells.length < 1 )
			return null ;

		// Get the cells whose right or left border is nearest to the mouse cursor's x coordinate.
		var minRxDist = null ;
		var lxDist = null ;
		var minYDist = null ;
		var rbCell = null ;
		var lbCell = null ;
		for ( var i = 0 ; i < cells.length ; i++ )
		{
			var pos = FCKDragTableHandler._GetWindowPosition( w, cells[i] ) ;
			var rightX = pos.x + parseInt( cells[i].clientWidth ) ;
			var rxDist = evt.clientX - rightX ;
			var yDist = evt.clientY - ( pos.y + ( cells[i].clientHeight / 2 ) ) ;
			if ( minRxDist == null || 
					( Math.abs( rxDist ) <= Math.abs( minRxDist ) &&
					  ( minYDist == null || Math.abs( yDist ) < Math.abs( minYDist ) ) ) )
			{
				minRxDist = rxDist ;
				minYDist = yDist ;
				rbCell = cells[i] ;
			}
		}
		var rowNode = FCKTools.GetElementAscensor( rbCell, "tr" ) ;
		var cellIndex = rbCell.cellIndex + 1 ;
		if ( cellIndex >= rowNode.cells.length )
			return null ;
		lbCell = rowNode.cells.item( cellIndex ) ;

		// Abort if too far from the border.
		lxDist = evt.clientX - FCKDragTableHandler._GetWindowPosition( w, lbCell ).x ;
		if ( lxDist < 0 && minRxDist < 0 && lxDist < -3 )
			return null ; 
		if ( lxDist > 0 && minRxDist > 0 && minRxDist > 3 )
			return null ;

		return { "leftCell" : rbCell, "rightCell" : lbCell } ;
	},
	"MouseDownListener" : function( FCK, evt )
	{
		if ( FCKDragTableHandler._LeftCell )
			FCKDragTableHandler._MouseMoveMode = 1 ;
	},
	"MouseUpListener" : function( FCK, evt )
	{
		FCKDragTableHandler._MouseMoveMode = 0 ;
	},
	"MouseMoveListener" : function( FCK, evt )
	{
		if ( FCKDragTableHandler._MouseMoveMode == 0 )
			return FCKDragTableHandler._MouseFindHandler( FCK, evt ) ;
		else
			return FCKDragTableHandler._MouseDragHandler( FCK, evt ) ;
	},
	"_ResizeBarMouseMoveListener" : function( evt )
	{
		if ( ! evt )
			evt = window.event ;		
		if ( FCKDragTableHandler._MouseMoveMode == 0 )
			return FCKDragTableHandler._MouseFindHandler( FCK, evt ) ;
		else
			return FCKDragTableHandler._MouseDragHandler( FCK, evt ) ;
	},
	// Calculate the padding of a table cell.
	// It returns the value of paddingLeft + paddingRight of a table cell.
	// This function is used, in part, to calculate the width parameter that should be used for setting cell widths.
	// The equation in question is clientWidth = paddingLeft + paddingRight + width.
	// So that width = clientWidth - paddingLeft - paddingRight.
	// The return value of this function must be pixel accurate acorss all supported browsers, so be careful if you need to modify it.
	"_GetCellPadding" : function( table, cell )
	{
		var attrGuess = parseInt( table.cellPadding ) * 2 ;
		var cssGuess = null ;
		if ( typeof( window.getComputedStyle ) == "function" )
		{
			var styleObj = window.getComputedStyle( cell, null ) ;
			cssGuess = parseInt( styleObj.getPropertyValue( "padding-left" ) ) + 
				parseInt( styleObj.getPropertyValue( "padding-right" ) ) ;
		}
		else
			cssGuess = parseInt( cell.currentStyle.paddingLeft ) + parseInt (cell.currentStyle.paddingRight ) ;

		var cssRuntime = cell.style.padding ;
		if ( parseInt( cssRuntime ) == parseInt( cssRuntime ) )
			cssGuess = parseInt( cssRuntime ) * 2 ;
		else
		{
			cssRuntime = cell.style.paddingLeft ;
			if ( parseInt( cssRuntime ) == parseInt( cssRuntime ) )
				cssGuess = parseInt( cssRuntime ) ;
			cssRuntime = cell.style.paddingRight ;
			if ( parseInt( cssRuntime ) == parseInt( cssRuntime ) )
				cssGuess += parseInt( cssRuntime ) ;
		}

		attrGuess = parseInt( attrGuess ) ;
		cssGuess = parseInt( cssGuess ) ;
		if ( attrGuess != attrGuess )
			attrGuess = 0 ;
		if ( cssGuess != cssGuess )
			cssGuess = 0 ;
		return Math.max( attrGuess, cssGuess ) ;
	},
	// Calculate the real width of the table cell.
	// The real width of the table cell is the pixel width that you can set to the width attribute of the table cell and after
	// that, the table cell should be of exactly the same width as before.
	// The real width of a table cell can be calculated as:
	// width = clientWidth - paddingLeft - paddingRight.
	"_GetCellWidth" : function( table, cell )
	{
		var clientWidth = parseInt( cell.clientWidth ) ;
		if ( clientWidth != clientWidth )		// NaN possible? lets just be safe...
			clientWidth = 0 ;
		return clientWidth - FCKDragTableHandler._GetCellPadding( table, cell ) ;
	},
	"_MouseFindHandler" : function( FCK, evt )
	{
		var node = evt.srcElement || evt.originalTarget ;
		try
		{
			if ( ! node || node.nodeType != 1 )
			{
				FCKDragTableHandler._HideResizeBar() ;
				return ;
			}
		}
		catch ( e )
		{
			FCKDragTableHandler._HideResizeBar() ;
			return ;
		}

		if ( FCKDragTableHandler._ResizeBar && FCKDragTableHandler._LeftCell )
		{
			var leftPos = FCKDragTableHandler._GetWindowPosition( FCK.EditorWindow, FCKDragTableHandler._LeftCell ) ;
			var rightPos = FCKDragTableHandler._GetWindowPosition( FCK.EditorWindow, FCKDragTableHandler._RightCell ) ; 
			var lxDist = evt.clientX - ( leftPos.x + FCKDragTableHandler._LeftCell.clientWidth ) ;
			var rxDist = evt.clientX - rightPos.x ;
			var inRangeFlag = false ;
			if ( lxDist >= 0 && rxDist <= 0 )
				inRangeFlag = true ;
			else if ( rxDist > 0 && rxDist < 3 )
				inRangeFlag = true ;
			else if ( lxDist < 0 && lxDist > -3 )
				inRangeFlag = true ;
			if ( inRangeFlag )
			{
				FCKDragTableHandler._ShowResizeBar( FCK.EditorWindow, 
					FCKTools.GetElementAscensor( FCKDragTableHandler._LeftCell, "table" ),
					evt ) ;
				return ;
			}
		}

		var tagName = node.tagName.toLowerCase() ;
		if ( tagName != "table" && tagName != "td" && tagName != "th" )
		{
			if ( FCKDragTableHandler._LeftCell )
			{
				FCKDragTableHandler._LeftCell.style.backgroundColor = "transparent";
				FCKDragTableHandler._RightCell.style.backgroundColor = "transparent";
				FCKDragTableHandler._LeftCell = FCKDragTableHandler._RightCell = null ;
			}
			FCKDragTableHandler._HideResizeBar() ;
			return ;
		}
		node = FCKTools.GetElementAscensor( node, "table" ) ;
		var cellTuple = FCKDragTableHandler._GetBorderCells( FCK.EditorWindow, node, evt ) ;

		if ( cellTuple == null )
		{
			if ( FCKDragTableHandler._LeftCell )
			{
				FCKDragTableHandler._LeftCell.style.backgroundColor = "transparent";
				FCKDragTableHandler._RightCell.style.backgroundColor = "transparent";
				FCKDragTableHandler._LeftCell = FCKDragTableHandler._RightCell = null ;
			}
			FCKDragTableHandler._HideResizeBar() ;
		}
		else
		{
			if (FCKDragTableHandler._LeftCell && FCKDragTableHandler._LeftCell != cellTuple["leftCell"])
			{
				FCKDragTableHandler._LeftCell.style.backgroundColor = "transparent";
				FCKDragTableHandler._RightCell.style.backgroundColor = "transparent";
			}
			FCKDragTableHandler._LeftCell = cellTuple["leftCell"] ;
			FCKDragTableHandler._RightCell = cellTuple["rightCell"] ;
			cellTuple["leftCell"].style.backgroundColor = "red";
			cellTuple["rightCell"].style.backgroundColor = "green";
			FCKDragTableHandler._ShowResizeBar( FCK.EditorWindow, 
					FCKTools.GetElementAscensor( FCKDragTableHandler._LeftCell, "table" ),
					evt ) ;
		}
	},
	"_MouseDragHandler" : function( FCK, evt )
	{
	},
	"_ShowResizeBar" : function( w, table, evt )
	{
		if ( FCKDragTableHandler._ResizeBar == null )
		{
			FCKDragTableHandler._ResizeBar = document.createElement( "div" ) ;
			var rb = FCKDragTableHandler._ResizeBar ;
			rb.style.position = "absolute" ;
			rb.style.backgroundColor = "blue" ;
			rb.style.cursor = "e-resize" ;
			if ( FCKBrowserInfo.IsIE )
				rb.style.filter = "progid:DXImageTransform.Microsoft.Alpha(opacity=25,enabled=true)" ;
			else
				rb.style.opacity = 0.25 ;
			document.body.appendChild( rb ) ;
		}

		var rb = FCKDragTableHandler._ResizeBar ;
		var offset = FCKDragTableHandler._GetDocumentPosition( window, FCK.EditingArea.IFrame ) ;
		rb.style.top = ( offset.y + FCKDragTableHandler._GetDocumentPosition( w, table ).y ) + "px" ;
		rb.style.height = table.offsetHeight + "px" ;
		var bw = parseInt( table.border ) ;
		if ( bw != bw )
			bw = 0 ;
		var cs = parseInt( table.cellSpacing ) ;
		if ( cs != cs )
			cs = 0 ;
		var barWidth = Math.max( bw, cs, 3 ) ;
		rb.style.width = barWidth + "px" ;
		rb.style.left = ( offset.x + evt.clientX + FCKDragTableHandler._GetWindowScrollX( w ) - barWidth / 2 ) +  "px" ;
		FCKTools.AddEventListener( rb, "mousemove", FCKDragTableHandler._ResizeBarMouseMoveListener ) ;
	},
	"_HideResizeBar" : function()
	{
		if ( FCKDragTableHandler._ResizeBar )
		{
			// IE bug: display : none does not hide the resize bar for some reason.
			// so set the position to somewhere invisible.
			FCKDragTableHandler._ResizeBar.style.top = "-100000px" ;
			FCKDragTableHandler._ResizeBar.style.left = "-100000px" ;
		}
	}
};

FCK.Events.AttachEvent( "OnMouseDown", FCKDragTableHandler.MouseDownListener ) ;
FCK.Events.AttachEvent( "OnMouseUp", FCKDragTableHandler.MouseUpListener ) ;
FCK.Events.AttachEvent( "OnMouseMove", FCKDragTableHandler.MouseMoveListener ) ;
